﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MorseCoder
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private Char[] Letters = new Char[] {'a', 'b', 'c', 'd', 'e', 'f', 'g',
          'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u',
          'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8',
          '9', ' ','?', ',','!','.',';','/','=', '-', '(', ')', '"',':', '_','@' };
        private String[] MorseCode = new String[] {".-", "-...", "-.-.",
          "-..", ".", "..-.", "--.", "....", "..", ".---", "-.-", ".-..", 
          "--", "-.", "---", ".--.", "--.-", ".-.", "...", "-", "..-", 
          "...-", ".--", "-..-", "-.--", "--..", "-----", ".----", "..---", 
          "...--", "....-", ".....", "-....", "--...", "---..", "----.", "/","..--..","--..--", "--...-",".-.-.-","-.-.-.","-..-.","-...-","-....-","-.--.","-.--.-",".-..-.","---...","..--.-",".--.-." };

        private String[] MorseBits = new String[] { ".", "-", " ", "..", ".-", ". ", "-.", "- ", "--", " .", " -", "  ", "...", "..-", ".. ", ".-.", ". .", "-..", " ..", ".--", ".- ", ". -", ".  ", "-.-", "-. ", " .-", " . ", "--.", "- .", " -.", "  .", "---", "-- ", "- -", " --", "-  ", " - ", "  -", "   " };
        private String[] Code = new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c" };
        public String ConvertTextToMorse(String text)
        {
            text = text.ToLower();
            String result = "";
            int index = -1;
            for (int i = 0; i <= text.Length - 1; i++)
            {
                index = Array.IndexOf(Letters, text[i]);
                if (index != -1)
                    result += MorseCode[index] + "/";
            }

            return result.Trim();

        }


        public String ConvertMorseToText(String text)
        {
            text = "@" + text.Replace("/", "@@") + "@";
            int index = -1;
            foreach (Char c in Letters)
            {
                index = Array.IndexOf(Letters, c);
                text = text.Replace("@" + MorseCode[index] + "@", "@" + c.ToString() + "@");
            }

            return text.Replace("@@@@", " ").Replace("@", "");
        }

        public String EncodeMorse(String Morse)
        {
            int Length = Morse.Length;
            String result = "";

            for (int i = 0; i <= Morse.Length - 1; i = i)
            {
                if (Length > 3)
                {
                    result += BitEncode(Morse.Substring(i, 3));
                    i = i + 3;
                    Length = Length - 3;
                }
                if (Length == 3)
                {
                    result += BitEncode(Morse.Substring(i, 3));
                    i = i + 3;
                    Length = Length - 3;
                    break;
                }
                if (Length == 2)
                {
                    result += BitEncode(Morse.Substring(i, 2));
                    i = i + 2;
                    Length = Length - 2;
                    break;
                }
                if (Length == 1)
                {
                    result += BitEncode(Morse.Substring(i, 1));

                    Length = Length - 1;

                    break;
                }
            }
            return result.Trim();
        }

        public String EncodeMorse2(String Morse)
        {
            int Length = Morse.Length;
            string result = "";
            string result2 = "";
            int i = 0;
            while (Length != 0)
            {
                if (Length >= 2 && Morse.Substring(i, 2) == "//")
                {
                    result2 += "01";
                    Length = Length - 2;
                    i = i + 2;
                }
                else if (Morse.Substring(i, 1) == ".")
                {
                    result2 += "10";
                    Length--;
                    i++;
                }
                else if (Morse.Substring(i, 1) == "-")
                {
                    result2 += "11";
                    Length--;
                    i++;
                }
                else if (Morse.Substring(i, 1) == "/")
                {
                    result2 += "00";
                    Length--;
                    i++;
                }
            }
            //if (result2.Length % 4 != 0)
            //{

            //    Length = result2.Length / 4 + 1;
            //    if (result2.Length % 4 == 1)
            //    {
            //        result2 = "000" + result2;
            //    }
            //    else if (result2.Length % 4 == 2)
            //    {
            //        result2 = "00" + result2;
            //    }
            //    else if (result2.Length % 4 == 3)
            //    {
            //        result2 = "0" + result2;
            //    }

            //}
            //else
            //{
            //    Length = result2.Length / 4;
            //}
            //if (result2.Length % 8 != 0)
            //{

            //    Length = result2.Length / 8 + 1;
            //    if (result2.Length % 8 == 1)
            //    {
            //        result2 = "0000000" + result2;
            //    }
            //    else if (result2.Length % 8 == 2)
            //    {
            //        result2 = "000000" + result2;
            //    }
            //    else if (result2.Length % 8 == 3)
            //    {
            //        result2 = "00000" + result2;
            //    }
            //    else if (result2.Length % 8 == 4)
            //    {
            //        result2 = "0000" + result2;
            //    }
            //    else if (result2.Length % 8 == 5)
            //    {
            //        result2 = "000" + result2;
            //    }
            //    else if (result2.Length % 8 == 6)
            //    {
            //        result2 = "00" + result2;
            //    }
            //    else if (result2.Length % 8 == 7)
            //    {
            //        result2 = "0" + result2;
            //    }
            //}
            //else
            //{
            //    Length = result2.Length / 8;
            //}
            //i = 0;
            //while (result2.Length >= 4)
            //{
            //    string pokus = result2.Substring(result2.Length - 4, 4);
            //    result = Convert.ToString(Convert.ToInt32(result2.Substring(result2.Length - 4, 4), 2), 16) + result;
            //    result2 = result2.Remove(result2.Length - 4);
            //}
            //   while (Length > 0)
            //    {
            //        string pokus = result2.Substring(i, 4);
            //        result += Convert.ToString(Convert.ToInt32(result2.Substring(i, 4), 2), 16);
            //        Length = Length - 1;
            //        i = i + 4;

            //}
            //Int64 result3 = 0;
            //i = 0;
            //Length = result2.Length;
            //while (Length > 0)
            //{
            //    string pokus = result2.Substring(Length - 1, 1);
            //    result3 += int.Parse(pokus) * (int)Math.Pow(3.0, i);
            //    Length = Length - 1;
            //    i++;

            //}
            //string result4 = ToBinary(result3);
            if (result2.Length % 8 != 0)
            {

                Length = result2.Length / 8 + 1;
                if (result2.Length % 8 == 1)
                {
                    result2 = "0000000" + result2;
                }
                else if (result2.Length % 8 == 2)
                {
                    result2 = "000000" + result2;
                }
                else if (result2.Length % 8 == 3)
                {
                    result2 = "00000" + result2;
                }
                else if (result2.Length % 8 == 4)
                {
                    result2 = "0000" + result2;
                }
                else if (result2.Length % 8 == 5)
                {
                    result2 = "000" + result2;
                }
                else if (result2.Length % 8 == 6)
                {
                    result2 = "00" + result2;
                }
                else if (result2.Length % 8 == 7)
                {
                    result2 = "0" + result2;
                }
            }
            else
            {
                Length = result2.Length / 8;
            }
            Length = result2.Length;
            string ascii = "";
            while (Length > 0)
            {
                string pokus = result2.Substring(Length - 8, 8);
                ascii += BinaryToInt(pokus);
                result += char.ConvertFromUtf32(BinaryToInt(pokus));
                Length = Length - 8;

            }
            return result;
        }

        public String DecodeMorse(String EncodedMorse)
        {
            String result = "";
            String[] letters = EncodedMorse.Split(' ');
            for (int j = 0; j < letters.Length; j++)
            {
                for (int i = 0; i < letters[j].Length; i++)
                {
                    result += BitDecode(letters[j].Substring(i, 1));
                }
                //result += " ";
            }
            return result.Trim();
        }
        public String DecodeMorse3(String EncodedMorse)
        {

            int Length = EncodedMorse.Length;
            string result = "";
            string result2 = "";
            int i = 0;
            while (i < Length)
            {
                string hex = Convert.ToString(Convert.ToInt32(EncodedMorse.Substring(i, 1), 16), 2);
                if (hex.Length == 1)
                {
                    hex = "000" + hex;
                }
                else if (hex.Length == 2)
                {
                    hex = "00" + hex;
                }
                if (hex.Length == 3)
                {
                    hex = "0" + hex;
                }
                result2 += hex;
                i = i + 1;
            }
            Length = result2.Length;
            while (result2.Length >= 3)
            {

                if (result2.Substring(result2.Length - 3, 3) == "100")
                {
                    result = "." + result;
                    result2 = result2.Remove(result2.Length - 3);
                }
                else if (result2.Substring(result2.Length - 3, 3) == "010")
                {
                    result = "-" + result;
                    result2 = result2.Remove(result2.Length - 3);
                }
                else if (result2.Substring(result2.Length - 3, 3) == "000")
                {
                    result2 = result2.Remove(result2.Length - 3);
                }
                else
                {
                    result = "/" + result;
                    result2 = result2.Remove(result2.Length - 3);
                }
            }


            return result.Trim();
        }
        public string DecodeMorse2(String EncodedMorse)
        {
            string result = "";
            string result3 = "";
            System.Text.Encoding ascii = System.Text.Encoding.Unicode;
            Byte[] encodedBytes = ascii.GetBytes(EncodedMorse);
            foreach (Byte b in encodedBytes)
            {
                string result2 = IntToBinary(b);
                if (b != 0)
                {
                    if (result2.Length % 8 != 0)
                    {

                        if (result2.Length % 8 == 1)
                        {
                            result2 = "0000000" + result2;
                        }
                        else if (result2.Length % 8 == 2)
                        {
                            result2 = "000000" + result2;
                        }
                        else if (result2.Length % 8 == 3)
                        {
                            result2 = "00000" + result2;
                        }
                        else if (result2.Length % 8 == 4)
                        {
                            result2 = "0000" + result2;
                        }
                        else if (result2.Length % 8 == 5)
                        {
                            result2 = "000" + result2;
                        }
                        else if (result2.Length % 8 == 6)
                        {
                            result2 = "00" + result2;
                        }
                        else if (result2.Length % 8 == 7)
                        {
                            result2 = "0" + result2;
                        }

                    }
                    result3 = result2 + result3;
                }
            }
            

            while (result3.StartsWith("0"))
            {
                result3 = result3.Remove(0, 1);
            }
            if (result3.Length % 2 != 0)
            {
                result3 = result3.Insert(0, "0");
            }
            int Length = result3.Length;
            int i = 0;
            while (Length > 0)
            {
                if (result3.Substring(i, 2) == "01")
                {
                    result += "//";
                    Length = Length - 2;
                    i = i + 2;
                }
                else if (result3.Substring(i, 2) == "10")
                {
                    result += ".";
                    Length = Length - 2;
                    i = i + 2;
                }
                else if (result3.Substring(i, 2) == "11")
                {
                    result += "-";
                    Length = Length - 2;
                    i = i + 2;
                }
                else if (result3.Substring(i, 2) == "00")
                {
                    result += "/";
                    Length = Length - 2;
                    i = i + 2;
                }
            }

            return result;
        }
        public String BitEncode(String BitString)
        {
            String result = "";
            int index = -1;

            index = Array.IndexOf(MorseBits, BitString);
            if (index != -1)
                result += Code[index];
            if (index == -1)
            {
            }

            return result.Trim();

        }
        public String BitDecode(String c)
        {
            String result = "";
            int index = -1;

            index = Array.IndexOf(Code, c);
            if (index != -1)
                result += MorseBits[index];

            return result;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string texttomorse = ConvertTextToMorse(tb_Text_IN.Text);
            tb_Morse_IN.Text = texttomorse;
            string encdodedmorse = EncodeMorse2(texttomorse);
            tb_Morse_Code.Text = encdodedmorse;
            string decodedmorse = DecodeMorse2(encdodedmorse);
            tb_Morse_Out.Text = decodedmorse;
            if (texttomorse == decodedmorse)
            {
                string morsetotext = ConvertMorseToText(decodedmorse).Trim();
                tb_Text_Out.Text = morsetotext;
            }
            double komprese = ((double)encdodedmorse.Length / (double)texttomorse.Length) * 100.0;
            label1.Text = "Kompresní poměr: " + ((int)(komprese)).ToString() + " %";


        }

        private void tb_Text_IN_KeyUp(object sender, KeyEventArgs e)
        {
            string clear = RemoveDiacritics(tb_Text_IN.Text);
            tb_Text_IN.Clear();
            tb_Text_IN.AppendText(clear);
        }
        public static string RemoveDiacritics(String s)
        {
            // oddělení znaků od modifikátorů (háčků, čárek, atd.)
            s = s.ToLower();
            s = s.Normalize(System.Text.NormalizationForm.FormD);
            System.Text.StringBuilder sb = new System.Text.StringBuilder();

            for (int i = 0; i < s.Length; i++)
            {
                // do řetězce přidá všechny znaky kromě modifikátorů
                if (System.Globalization.CharUnicodeInfo.GetUnicodeCategory(s[i]) != System.Globalization.UnicodeCategory.NonSpacingMark)
                {
                    sb.Append(s[i]);
                }
            }

            // vrátí řetězec bez diakritiky
            return sb.ToString();
        }
        private string ToBinary(Int64 Decimal)
        {

            // Declare a few variables we're going to need

            Int64 BinaryHolder;

            char[] BinaryArray;

            string BinaryResult = "";

            while (Decimal > 0)
            {

                BinaryHolder = Decimal % 2;

                BinaryResult += BinaryHolder;

                Decimal = Decimal / 2;

            }

            // The algoritm gives us the binary number in reverse order (mirrored)

            // We store it in an array so that we can reverse it back to normal

            BinaryArray = BinaryResult.ToCharArray();

            Array.Reverse(BinaryArray);

            BinaryResult = new string(BinaryArray);

            return BinaryResult;

        }
        private string To256(Int64 Decimal)
        {

            // Declare a few variables we're going to need

            Int64 BinaryHolder;

            char[] BinaryArray;

            string BinaryResult = "";

            while (Decimal > 0)
            {

                BinaryHolder = Decimal % 256;

                BinaryResult += BinaryHolder;

                Decimal = Decimal / 256;

            }

            // The algoritm gives us the binary number in reverse order (mirrored)

            // We store it in an array so that we can reverse it back to normal

            BinaryArray = BinaryResult.ToCharArray();

            Array.Reverse(BinaryArray);

            BinaryResult = new string(BinaryArray);

            return BinaryResult;

        }
        private string IntToBinary(int cislo)
        {

            //To Binary from Integer


            int baze = 2;

            return Convert.ToString(cislo, baze);
        }


        private int BinaryToInt(string binary)
        {
            //To Integer From Binary
            int baze = 2;


            return Convert.ToInt32(binary, baze);
        }

    }
}
